"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestStatus = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class QuestStatus extends JSONTemplate_1.JSONTemplate {
    emulator;
    constructor(emu, core) {
        super();
        this.emulator = emu;
    }
    jsonFields = [
        "max_hp",
        "currentWallet",
        "ordonSword",
        "masterSword",
        "ordonShield",
        "woodenShield",
        "hylianShield",
        "heroArmor",
        "zoraArmor",
        "magicArmor",
        "goldenBugs",
        "hiddenSkills",
        "poeCount",
        "scent",
        "wooden_sword",
        "dominion_flag",
        "fusedShadow1",
        "fusedShadow2",
        "fusedShadow3",
        "mirrorShard1",
        "mirrorShard2",
        "mirrorShard3",
        "mirrorShard4",
    ];
    get max_hp() {
        return this.emulator.rdramRead8(0x804061C1);
    }
    set max_hp(flag) {
        this.emulator.rdramWrite8(0x804061C1, flag);
    }
    get current_hp() {
        return this.emulator.rdramRead8(0x804061C3);
    }
    set current_hp(flag) {
        this.emulator.rdramWrite8(0x804061C3, flag);
    }
    get swordEquip() {
        return this.emulator.rdramRead8(0x804061D4);
    }
    set swordEquip(flag) {
        this.emulator.rdramWrite8(0x804061D4, flag);
    }
    get shieldEquip() {
        return this.emulator.rdramRead8(0x804061D5);
    }
    set shieldEquip(flag) {
        this.emulator.rdramWrite8(0x804061D5, flag);
    }
    get clothing() {
        return this.emulator.rdramRead8(0x804061D3);
    }
    set clothing(flag) {
        this.emulator.rdramWrite8(0x804061D3, flag);
    }
    get form() {
        return this.emulator.rdramRead8(0x804061DE);
    }
    set form(flag) {
        this.emulator.rdramWrite8(0x804061DE, flag);
    }
    get rupees() {
        return this.emulator.rdramRead16(0x804061C4);
    }
    set rupees(flag) {
        this.emulator.rdramWrite16(0x804061C4, flag);
    }
    get currentWallet() {
        return this.emulator.rdramRead8(0x804061D9);
    }
    set currentWallet(flag) {
        this.emulator.rdramWrite8(0x804061D9, flag);
    }
    get ordonSword() {
        return this.emulator.rdramReadBit8(0x80406292, 7);
    }
    set ordonSword(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 7, flag);
    }
    get masterSword() {
        return this.emulator.rdramReadBit8(0x80406292, 6);
    }
    set masterSword(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 6, flag);
    }
    get masterSwordTwilightFlag() {
        return this.emulator.rdramReadBit8(0x80406296, 1);
    }
    set masterSwordTwilightFlag(flag) {
        this.emulator.rdramWriteBit8(0x80406296, 1, flag);
    }
    get ordonShield() {
        return this.emulator.rdramReadBit8(0x80406292, 5);
    }
    set ordonShield(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 5, flag);
    }
    get woodenShield() {
        return this.emulator.rdramReadBit8(0x80406292, 4);
    }
    set woodenShield(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 4, flag);
    }
    get hylianShield() {
        return this.emulator.rdramReadBit8(0x80406292, 3);
    }
    set hylianShield(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 3, flag);
    }
    get heroArmor() {
        return this.emulator.rdramReadBit8(0x80406292, 0);
    }
    set heroArmor(flag) {
        this.emulator.rdramWriteBit8(0x80406292, 0, flag);
    }
    get zoraArmor() {
        return this.emulator.rdramReadBit8(0x80406291, 6);
    }
    set zoraArmor(flag) {
        this.emulator.rdramWriteBit8(0x80406291, 6, flag);
    }
    get magicArmor() {
        return this.emulator.rdramReadBit8(0x80406291, 7);
    }
    set magicArmor(flag) {
        this.emulator.rdramWriteBit8(0x80406291, 7, flag);
    }
    get goldenBugs() {
        return this.emulator.rdramReadBuffer(0x804062A5, 0x3);
    }
    set goldenBugs(flag) {
        this.emulator.rdramWriteBuffer(0x804062A5, flag);
    }
    get hiddenSkills() {
        return this.emulator.rdramRead16(0x804069D9);
    }
    set hiddenSkills(flag) {
        this.emulator.rdramWrite16(0x804069D9, flag);
    }
    get poeCount() {
        return this.emulator.rdramRead8(0x804062CC);
    }
    set poeCount(flag) {
        this.emulator.rdramWrite8(0x804062CC, flag);
    }
    get scent() {
        return this.emulator.rdramRead8(0x804061D6);
    }
    set scent(flag) {
        this.emulator.rdramWrite8(0x804061D6, flag);
    }
    get wooden_sword() {
        return this.emulator.rdramRead8(0x80406290);
    }
    set wooden_sword(flag) {
        this.emulator.rdramWrite8(0x80406290, flag);
    }
    get dominion_flag() {
        return this.emulator.rdramRead8(0x804069D5);
    }
    set dominion_flag(flag) {
        this.emulator.rdramWrite8(0x804069D5, flag);
    }
    get fusedShadow1() {
        return this.emulator.rdramReadBit8(0x804062C9, 7);
    }
    set fusedShadow1(flag) {
        this.emulator.rdramWriteBit8(0x804062C9, 7, flag);
    }
    get fusedShadow2() {
        return this.emulator.rdramReadBit8(0x804062C9, 6);
    }
    set fusedShadow2(flag) {
        this.emulator.rdramWriteBit8(0x804062C9, 6, flag);
    }
    get fusedShadow3() {
        return this.emulator.rdramReadBit8(0x804062C9, 5);
    }
    set fusedShadow3(flag) {
        this.emulator.rdramWriteBit8(0x804062C9, 5, flag);
    }
    get mirrorShard1() {
        return this.emulator.rdramReadBit8(0x804062CA, 7);
    }
    set mirrorShard1(flag) {
        this.emulator.rdramWriteBit8(0x804062CA, 7, flag);
    }
    get mirrorShard2() {
        return this.emulator.rdramReadBit8(0x804062CA, 6);
    }
    set mirrorShard2(flag) {
        this.emulator.rdramWriteBit8(0x804062CA, 6, flag);
    }
    get mirrorShard3() {
        return this.emulator.rdramReadBit8(0x804062CA, 5);
    }
    set mirrorShard3(flag) {
        this.emulator.rdramWriteBit8(0x804062CA, 5, flag);
    }
    get mirrorShard4() {
        return this.emulator.rdramReadBit8(0x804062CA, 4);
    }
    set mirrorShard4(flag) {
        this.emulator.rdramWriteBit8(0x804062CA, 4, flag);
    }
}
exports.QuestStatus = QuestStatus;
//# sourceMappingURL=QuestStatus.js.map