"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShieldsEquipment = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class ShieldsEquipment extends JSONTemplate_1.JSONTemplate {
    emulator;
    core;
    jsonFields = ['shieldLevel'];
    constructor(emulator, core) {
        super();
        this.emulator = emulator;
        this.core = core;
    }
    get shieldLevel() {
        let bits = this.emulator.rdramReadBits8(0x80406292); //Shield bitfield
        if (bits[5 /* ShieldBitMap.Ordon */] === 1) {
            return 1 /* Shield.Ordon */;
        }
        else if (bits[4 /* ShieldBitMap.Wooden */] === 1) {
            return 2 /* Shield.Wooden */;
        }
        else if (bits[3 /* ShieldBitMap.Hylian */] === 1) {
            return 3 /* Shield.Hylian */;
        }
        else {
            return 0 /* Shield.NONE */;
        }
    }
    set shieldLevel(level) {
        let bits = this.emulator.rdramReadBits8(0x80406292);
        switch (level) {
            case 3 /* Shield.Hylian */:
                bits[3 /* ShieldBitMap.Hylian */] = 1;
                break;
            case 1 /* Shield.Ordon */:
                bits[5 /* ShieldBitMap.Ordon */] = 1;
                bits[4 /* ShieldBitMap.Wooden */] = 0;
                break;
            case 2 /* Shield.Wooden */:
                bits[5 /* ShieldBitMap.Ordon */] = 0;
                bits[4 /* ShieldBitMap.Wooden */] = 1;
                break;
        }
        this.emulator.rdramWriteBits8(0x80406292, bits);
    }
}
exports.ShieldsEquipment = ShieldsEquipment;
//# sourceMappingURL=ShieldsEquipment.js.map