"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StageInfo = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class StageInfo extends JSONTemplate_1.JSONTemplate {
    emulator;
    dSv_info_c = 0x804061C0;
    stageInfoAddr = this.dSv_info_c + 0x1F0;
    stageID;
    jsonFields = [
        "chests",
        "switches",
        "items",
        "rooms",
        "keys",
        "dungeonItem"
    ];
    constructor(emu, stageID, instance) {
        super();
        this.emulator = emu;
        this.stageID = stageID;
        if (instance !== undefined) {
            this.stageInfoAddr = instance;
        }
    }
    get chests() {
        return this.emulator.rdramReadBuffer(this.stageInfoAddr + (0x20 * this.stageID), 0x8);
    }
    set chests(flag) {
        this.emulator.rdramWriteBuffer(this.stageInfoAddr + (0x20 * this.stageID), flag);
    }
    get switches() {
        return this.emulator.rdramReadBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x8, 0x10);
    }
    set switches(flag) {
        this.emulator.rdramWriteBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x8, flag);
    }
    get items() {
        return this.emulator.rdramReadBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x18, 0x4);
    }
    set items(flag) {
        this.emulator.rdramWriteBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x18, flag);
    }
    get keys() {
        return this.emulator.rdramRead8(this.stageInfoAddr + (0x20 * this.stageID) + 0x1C);
    }
    set keys(flag) {
        this.emulator.rdramWrite8(this.stageInfoAddr + (0x20 * this.stageID) + 0x1C, flag);
    }
    get dungeonItem() {
        return this.emulator.rdramReadBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x1D, 0x1);
    }
    set dungeonItem(flag) {
        this.emulator.rdramWriteBuffer(this.stageInfoAddr + (0x20 * this.stageID) + 0x1D, flag);
    }
}
exports.StageInfo = StageInfo;
//# sourceMappingURL=StageInfo.js.map