"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SwordsEquipment = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class SwordsEquipment extends JSONTemplate_1.JSONTemplate {
    emulator;
    core;
    jsonFields = [
        'swordLevel',
    ];
    constructor(emulator, core) {
        super();
        this.emulator = emulator;
        this.core = core;
    }
    get swordLevel() {
        let bits = this.emulator.rdramReadBits8(0x80406292); //Sword bitfield
        if (bits[6 /* SwordBitMap.Master */] === 1) {
            return 2 /* Sword.Master */;
        }
        else if (bits[7 /* SwordBitMap.Ordon */] === 1) {
            return 1 /* Sword.Ordon */;
        }
        else {
            return 0 /* Sword.NONE */;
        }
    }
    set swordLevel(level) {
        let bits = this.emulator.rdramReadBits8(0x80406292);
        switch (level) {
            case 0 /* Sword.NONE */:
                bits[7 /* SwordBitMap.Ordon */] = 0;
                bits[6 /* SwordBitMap.Master */] = 0;
                break;
            case 1 /* Sword.Ordon */:
                bits[7 /* SwordBitMap.Ordon */] = 1;
                bits[6 /* SwordBitMap.Master */] = 0;
                break;
            case 2 /* Sword.Master */:
                bits[7 /* SwordBitMap.Ordon */] = 1;
                bits[6 /* SwordBitMap.Master */] = 1;
                break;
        }
        this.emulator.rdramWriteBits8(0x80406292, bits);
    }
}
exports.SwordsEquipment = SwordsEquipment;
//# sourceMappingURL=SwordsEquipment.js.map