"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WWHelper = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class WWHelper extends JSONTemplate_1.JSONTemplate {
    save;
    global;
    link;
    emu;
    constructor(save, global, link, memory) {
        super();
        this.save = save;
        this.global = global;
        this.link = link;
        this.emu = memory;
    }
    isLinkControllable() {
        let r1 = this.emu.rdramRead8(0x803DC41C);
        return (r1 === 0 && !this.isLoadingZone() && !this.isPaused());
    }
    isTitleScreen() {
        return (this.global.current_scene_name === "F_SP102" || this.global.current_scene_name === "S_MV000");
    }
    isSceneChange() {
        let r1 = this.global.current_scene_frame;
        return (r1 === 0x00000000);
    }
    isLoadingZone() {
        let r1 = this.emu.rdramRead32(0x80450CE0);
        return (r1 === 0x1);
    }
    isLinkExists() {
        return (this.global.linkPointer !== 0x0);
    }
    isSceneNameValid() {
        return this.global.current_scene_name !== "NULL" && !this.isTitleScreen();
    }
    isPaused() {
        return this.emu.rdramRead8(0x8040C04F) !== 0x0;
    }
}
exports.WWHelper = WWHelper;
//# sourceMappingURL=TPHelper.js.map