"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Inventory = void 0;
const API = __importStar(require("../API/Imports"));
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
class Inventory extends JSONTemplate_1.JSONTemplate {
    emulator;
    instance = 0x8040625C;
    slotInstance = 0x80406274;
    bottleID = [
        API.InventoryItem.bottle_empty,
        API.InventoryItem.RedPotion, API.InventoryItem.MagicPotion, API.InventoryItem.BluePotion, API.InventoryItem.Milk,
        API.InventoryItem.MilkHalf, API.InventoryItem.LanternOil, API.InventoryItem.Water, API.InventoryItem.LanternOil2,
        API.InventoryItem.RedPotion2, API.InventoryItem.NastySoup, API.InventoryItem.HotSpringwater, API.InventoryItem.Fairy,
        API.InventoryItem.HotSpringwater2, API.InventoryItem.LaternOil, API.InventoryItem.LaternOil2, API.InventoryItem.FairysTears,
        API.InventoryItem.Worm, API.InventoryItem.GreatFairysTears, API.InventoryItem.BeeLarva, API.InventoryItem.RareChuJelly,
        API.InventoryItem.RedChuJelly, API.InventoryItem.BlueChuJelly, API.InventoryItem.GreenChuJelly, API.InventoryItem.YellowChuJelly,
        API.InventoryItem.PurpleChuJelly, API.InventoryItem.SimpleSoup, API.InventoryItem.GoodSoup, API.InventoryItem.SuperbSoup,
    ];
    bombID = [
        API.InventoryItem.bombNormal,
        API.InventoryItem.bombWater,
        API.InventoryItem.bombBug,
        API.InventoryItem.bombEmpty
    ];
    constructor(emu) {
        super();
        this.emulator = emu;
    }
    jsonFields = [
        'galeBoomerang',
        'lantern',
        'spinner',
        'ironBoots',
        'bow',
        'hawkeye',
        'ballAndChain',
        'dominionRod',
        'clawshot',
        'slingshot',
        'bottle1',
        'bottle2',
        'bottle3',
        'bottle4',
        'bombBag1',
        'bombBag2',
        'bombBag3',
        'fishingRod',
        'horseCall',
        'skyBook',
        'questItem',
        'ooccoo'
    ];
    totalSlots = 24 /* InventorySlots.SLOT_24 */;
    get itemSlots() {
        return this.emulator.rdramReadBuffer(this.slotInstance, this.totalSlots);
    }
    set itemSlots(slots) {
        this.emulator.rdramWriteBuffer(this.slotInstance, slots);
    }
    getItem(item) {
        return this.itemSlots.indexOf(item) > -1 ? item : 0xFF;
    }
    addItemSlot(item) {
        let slots = this.itemSlots;
        if (slots.indexOf(item) > -1) {
            // The item already exists.
        }
        else {
            // The item does not exist.
            let empty = slots.indexOf(0xFF);
            if (empty === -1) {
                // No empty slots. Panic?
            }
            else {
                slots[empty] = item;
            }
        }
        this.itemSlots = slots;
    }
    //Inventory Items
    get galeBoomerang() {
        let val = this.getItem(0 /* API.InventorySlotItems.galeBoomerang */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set galeBoomerang(bool) {
        let value = bool ? API.InventoryItem.galeBoomerang : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance, value);
        if (bool)
            this.addItemSlot(0 /* InventorySlotItems.galeBoomerang */);
    }
    get lantern() {
        let val = this.getItem(1 /* API.InventorySlotItems.lantern */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set lantern(bool) {
        let value = bool ? API.InventoryItem.lantern : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 1, value);
        if (bool) {
            this.addItemSlot(1 /* InventorySlotItems.lantern */);
            //Lamp Oil
            this.emulator.rdramWrite16(0x804061C6, 0x5460); // Max size
            this.emulator.rdramWrite16(0x804061C8, 0x5460); // Current amount
        }
    }
    get spinner() {
        let val = this.getItem(2 /* API.InventorySlotItems.spinner */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set spinner(bool) {
        let value = bool ? API.InventoryItem.spinner : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 2, value);
        if (bool)
            this.addItemSlot(2 /* InventorySlotItems.spinner */);
    }
    get ironBoots() {
        let val = this.getItem(3 /* API.InventorySlotItems.ironBoots */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set ironBoots(bool) {
        let value = bool ? API.InventoryItem.ironBoots : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 3, value);
        if (bool)
            this.addItemSlot(3 /* InventorySlotItems.ironBoots */);
    }
    get bow() {
        let val = this.getItem(4 /* API.InventorySlotItems.bow */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set bow(bool) {
        let value = bool ? API.InventoryItem.bow : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 4, value);
        if (bool)
            this.addItemSlot(4 /* InventorySlotItems.bow */);
        if (this.arrows === 0)
            this.arrows = this.quiver;
    }
    get hawkeye() {
        let val = this.getItem(5 /* API.InventorySlotItems.hawkeye */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set hawkeye(bool) {
        let value = bool ? API.InventoryItem.hawkeye : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 5, value);
        if (bool)
            this.addItemSlot(5 /* InventorySlotItems.hawkeye */);
    }
    get ballAndChain() {
        let val = this.getItem(6 /* API.InventorySlotItems.ballAndChain */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set ballAndChain(bool) {
        let value = bool ? API.InventoryItem.ballAndChain : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 6, value);
        if (bool)
            this.addItemSlot(6 /* InventorySlotItems.ballAndChain */);
    }
    get dominionRod() {
        let val = this.getItem(8 /* API.InventorySlotItems.dominionRod */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set dominionRod(bool) {
        let value = bool ? API.InventoryItem.dominionRod : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 8, value);
        if (bool)
            this.addItemSlot(8 /* InventorySlotItems.dominionRod */);
    }
    get clawshot() {
        let clawshot = this.emulator.rdramRead8(this.instance + 9);
        let dblClawshot = this.emulator.rdramRead8(this.instance + 10);
        if (clawshot === API.InventoryItem.clawshot && dblClawshot !== API.InventoryItem.doubleClawshot)
            return API.InventoryItem.clawshot;
        else if (dblClawshot === API.InventoryItem.doubleClawshot)
            return API.InventoryItem.doubleClawshot;
        return API.InventoryItem.NONE;
    }
    set clawshot(item) {
        if (item === API.InventoryItem.clawshot) {
            this.emulator.rdramWrite8(this.instance + 9, API.InventoryItem.clawshot);
            this.emulator.rdramWrite8(this.instance + 10, API.InventoryItem.NONE);
            this.addItemSlot(9 /* InventorySlotItems.clawshot */);
        }
        if (item === API.InventoryItem.doubleClawshot) {
            this.emulator.rdramWrite8(this.instance + 9, API.InventoryItem.NONE);
            this.emulator.rdramWrite8(this.instance + 10, API.InventoryItem.doubleClawshot);
            this.addItemSlot(10 /* InventorySlotItems.dblClawshot */);
        }
        if (item === API.InventoryItem.NONE) {
            this.emulator.rdramWrite8(this.instance + 9, API.InventoryItem.NONE);
            this.emulator.rdramWrite8(this.instance + 10, API.InventoryItem.NONE);
        }
    }
    get bottle1() {
        let bottle = this.emulator.rdramRead8(this.instance + 11);
        if (this.bottleID.includes(bottle))
            return bottle;
        return API.InventoryItem.NONE;
    }
    set bottle1(item) {
        if (this.bottleID.includes(item))
            this.emulator.rdramWrite8(this.instance + 11, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(11 /* InventorySlotItems.bottle1 */);
    }
    get bottle2() {
        let bottle = this.emulator.rdramRead8(this.instance + 12);
        if (this.bottleID.includes(bottle))
            return bottle;
        return API.InventoryItem.NONE;
    }
    set bottle2(item) {
        if (this.bottleID.includes(item))
            this.emulator.rdramWrite8(this.instance + 12, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(12 /* InventorySlotItems.bottle2 */);
    }
    get bottle3() {
        let bottle = this.emulator.rdramRead8(this.instance + 13);
        if (this.bottleID.includes(bottle))
            return bottle;
        return API.InventoryItem.NONE;
    }
    set bottle3(item) {
        if (this.bottleID.includes(item))
            this.emulator.rdramWrite8(this.instance + 13, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(13 /* InventorySlotItems.bottle3 */);
    }
    get bottle4() {
        let bottle = this.emulator.rdramRead8(this.instance + 14);
        if (this.bottleID.includes(bottle))
            return bottle;
        return API.InventoryItem.NONE;
    }
    set bottle4(item) {
        if (this.bottleID.includes(item))
            this.emulator.rdramWrite8(this.instance + 14, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(14 /* InventorySlotItems.bottle4 */);
    }
    get bombBag1() {
        let bomb = this.emulator.rdramRead8(this.instance + 15);
        if (this.bombID.includes(bomb))
            return bomb;
        else
            return API.InventoryItem.NONE;
    }
    set bombBag1(item) {
        if (this.bombID.includes(item)) {
            this.emulator.rdramWrite8(this.instance + 15, item);
            this.addItemSlot(15 /* InventorySlotItems.bombs1 */);
        }
    }
    get bombBag2() {
        let bomb = this.emulator.rdramRead8(this.instance + 16);
        if (this.bombID.includes(bomb))
            return bomb;
        else
            return API.InventoryItem.NONE;
    }
    set bombBag2(item) {
        if (this.bombID.includes(item)) {
            this.emulator.rdramWrite8(this.instance + 16, item);
            this.addItemSlot(16 /* InventorySlotItems.bombs2 */);
        }
    }
    get bombBag3() {
        let bomb = this.emulator.rdramRead8(this.instance + 17);
        if (this.bombID.includes(bomb))
            return bomb;
        else
            return API.InventoryItem.NONE;
    }
    set bombBag3(item) {
        if (this.bombID.includes(item)) {
            this.emulator.rdramWrite8(this.instance + 17, item);
            this.addItemSlot(17 /* InventorySlotItems.bombs3 */);
        }
    }
    get ooccoo() {
        let item = this.emulator.rdramRead8(this.instance + 18);
        if (item === API.InventoryItem.ooccooJr)
            return API.InventoryItem.ooccooJr;
        else if (item === API.InventoryItem.ooccoo)
            return API.InventoryItem.ooccoo;
        return API.InventoryItem.NONE;
    }
    set ooccoo(item) {
        this.emulator.rdramWrite8(this.instance + 18, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(18 /* InventorySlotItems.ooccoo */);
    }
    get questItem() {
        let questItems = [API.InventoryItem.ronadoLetter, API.InventoryItem.invoice, API.InventoryItem.woodenSatue, API.InventoryItem.auroMemo, API.InventoryItem.asheiSketch];
        let item = this.emulator.rdramRead8(this.instance + 19);
        if (questItems.includes(item))
            return item;
        else
            return API.InventoryItem.NONE;
    }
    set questItem(item) {
        this.emulator.rdramWrite8(this.instance + 19, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(19 /* InventorySlotItems.questItem */);
    }
    get fishingRod() {
        let item = this.emulator.rdramRead8(this.instance + 20);
        if (item === API.InventoryItem.fishingRodEaringWorm)
            return API.InventoryItem.fishingRodEaringWorm;
        else if (item === API.InventoryItem.fishingRodEaring)
            return API.InventoryItem.fishingRodEaring;
        else if (item === API.InventoryItem.fishingRod)
            return API.InventoryItem.fishingRod;
        return API.InventoryItem.NONE;
    }
    set fishingRod(item) {
        this.emulator.rdramWrite8(this.instance + 20, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(20 /* InventorySlotItems.fishingRod */);
    }
    get horseCall() {
        let val = this.getItem(21 /* API.InventorySlotItems.horseCall */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set horseCall(bool) {
        let value = bool ? API.InventoryItem.horseCall : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 21, value);
        if (bool)
            this.addItemSlot(21 /* InventorySlotItems.horseCall */);
    }
    get skyBook() {
        let item = this.emulator.rdramRead8(this.instance + 22);
        if (item === API.InventoryItem.skyBookFilled)
            return API.InventoryItem.skyBookFilled;
        else if (item === API.InventoryItem.skyBook)
            return API.InventoryItem.skyBook;
        return API.InventoryItem.NONE;
    }
    set skyBook(item) {
        this.emulator.rdramWrite8(this.instance + 22, item);
        if (item !== API.InventoryItem.NONE)
            this.addItemSlot(22 /* InventorySlotItems.skyBook */);
    }
    get slingshot() {
        let val = this.getItem(23 /* API.InventorySlotItems.slingshot */);
        return !(val === 255 /* API.InventorySlotItems.NONE */);
    }
    set slingshot(bool) {
        let value = bool ? API.InventoryItem.slingshot : API.InventoryItem.NONE;
        this.emulator.rdramWrite8(this.instance + 23, value);
        if (bool) {
            this.addItemSlot(23 /* InventorySlotItems.slingshot */);
            this.dekuSeeds = 50;
        }
    }
    get quiver() {
        return this.emulator.rdramRead8(0x804062B8);
    }
    set quiver(flag) {
        this.emulator.rdramWrite8(0x804062B8, flag);
    }
    // Counts
    get dekuSeeds() {
        return this.emulator.rdramRead8(0x804062B4);
    }
    set dekuSeeds(flag) {
        this.emulator.rdramWrite8(0x804062B4, flag);
    }
    get arrows() {
        return this.emulator.rdramRead8(0x804062AC);
    }
    set arrows(flag) {
        this.emulator.rdramWrite8(0x804062AC, flag);
    }
    get bombs1() {
        return this.emulator.rdramRead8(0x804062AD);
    }
    set bombs1(flag) {
        this.emulator.rdramWrite8(0x804062AD, flag);
    }
    get bombs2() {
        return this.emulator.rdramRead8(0x804062AE);
    }
    set bombs2(flag) {
        this.emulator.rdramWrite8(0x804062AE, flag);
    }
    get bombs3() {
        return this.emulator.rdramRead8(0x804062AF);
    }
    set bombs3(flag) {
        this.emulator.rdramWrite8(0x804062AF, flag);
    }
}
exports.Inventory = Inventory;
//# sourceMappingURL=Inventory.js.map