"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveContext = void 0;
const JSONTemplate_1 = require("modloader64_api/JSONTemplate");
const CORE = __importStar(require("./Imports"));
const StageInfo_1 = require("./StageInfo");
class SaveContext extends JSONTemplate_1.JSONTemplate {
    emulator;
    core;
    dSv_info_c = 0x804061C0;
    eventFlagAddr = this.dSv_info_c + 0x7F0; //0x804069B0
    regionFlagAddr = this.dSv_info_c + 0x1F0; //0x804063B0;
    liveFlagAddr = this.dSv_info_c + 0x958; //0x80406B18; 
    inventory;
    questStatus;
    stage_Live;
    stage0_Ordon;
    stage1_Sewers;
    stage2_Faron;
    stage3_Eldin;
    stage4_Laynaru;
    stage5_Unk1;
    stage6_CastleField;
    stage7_SacredGrove;
    stage8_Snowpeak;
    stage9_CastleTown;
    stageA_Gerudo;
    stageB_FishingHole;
    stageC_Unk2;
    stageD_Unk3;
    stageE_Unk4;
    stageF_Unk5;
    stage10_ForestTemple;
    stage11_GoronMines;
    stage12_LakebedTemple;
    stage13_ArbitersGrounds;
    stage14_SnowpeakRuins;
    stage15_TempleOfTime;
    stage16_CitySky;
    stage17_PalaceTwilight;
    stage18_HyruleCastle;
    stage19_Cave1;
    stage1A_Cave2;
    stage1B_Grottos;
    stage1C_Unk6;
    stage1D_Unk7;
    stage1E_Unk8;
    stage1F_Unk9;
    jsonFields = [
        "inventory",
        'questStatus',
        "eventFlags",
        "charloDonation",
        "maloDonation",
        "mapFlags",
        "itemFlags",
        "faronTears",
        "eldinTears",
        "lanayruTears",
        "fusedShadowFlags",
        "twilightMirrorFlags",
        "letterFlags",
        "stage_Live",
        "stage0_Ordon",
        "stage1_Sewers",
        "stage2_Faron",
        "stage3_Eldin",
        "stage4_Laynaru",
        "stage5_Unk1",
        "stage6_CastleField",
        "stage7_SacredGrove",
        "stage8_Snowpeak",
        "stage9_CastleTown",
        "stageA_Gerudo",
        "stageB_FishingHole",
        "stageC_Unk2",
        "stageD_Unk3",
        "stageE_Unk4",
        "stageF_Unk5",
        "stage10_ForestTemple",
        "stage11_GoronMines",
        "stage12_LakebedTemple",
        "stage13_ArbitersGrounds",
        "stage14_SnowpeakRuins",
        "stage15_TempleOfTime",
        "stage16_CitySky",
        "stage17_PalaceTwilight",
        "stage18_HyruleCastle",
        "stage19_Cave1",
        "stage1A_Cave2",
        "stage1B_Grottos",
        "stage1C_Unk6",
        "stage1D_Unk7",
        "stage1E_Unk8",
        "stage1F_Unk9",
    ];
    constructor(emu, core) {
        super();
        this.emulator = emu;
        this.core = core;
        this.inventory = new CORE.Inventory(emu);
        this.questStatus = new CORE.QuestStatus(emu, core);
        this.stage_Live = new StageInfo_1.StageInfo(emu, 0x0, 0x80406B18);
        this.stage0_Ordon = new StageInfo_1.StageInfo(emu, 0x0);
        this.stage1_Sewers = new StageInfo_1.StageInfo(emu, 0x1);
        this.stage2_Faron = new StageInfo_1.StageInfo(emu, 0x2);
        this.stage3_Eldin = new StageInfo_1.StageInfo(emu, 0x3);
        this.stage4_Laynaru = new StageInfo_1.StageInfo(emu, 0x4);
        this.stage5_Unk1 = new StageInfo_1.StageInfo(emu, 0x5);
        this.stage6_CastleField = new StageInfo_1.StageInfo(emu, 0x6);
        this.stage7_SacredGrove = new StageInfo_1.StageInfo(emu, 0x7);
        this.stage8_Snowpeak = new StageInfo_1.StageInfo(emu, 0x8);
        this.stage9_CastleTown = new StageInfo_1.StageInfo(emu, 0x9);
        this.stageA_Gerudo = new StageInfo_1.StageInfo(emu, 0xA);
        this.stageB_FishingHole = new StageInfo_1.StageInfo(emu, 0xB);
        this.stageC_Unk2 = new StageInfo_1.StageInfo(emu, 0xC);
        this.stageD_Unk3 = new StageInfo_1.StageInfo(emu, 0xD);
        this.stageE_Unk4 = new StageInfo_1.StageInfo(emu, 0xE);
        this.stageF_Unk5 = new StageInfo_1.StageInfo(emu, 0xF);
        this.stage10_ForestTemple = new StageInfo_1.StageInfo(emu, 0x10);
        this.stage11_GoronMines = new StageInfo_1.StageInfo(emu, 0x11);
        this.stage12_LakebedTemple = new StageInfo_1.StageInfo(emu, 0x12);
        this.stage13_ArbitersGrounds = new StageInfo_1.StageInfo(emu, 0x13);
        this.stage14_SnowpeakRuins = new StageInfo_1.StageInfo(emu, 0x14);
        this.stage15_TempleOfTime = new StageInfo_1.StageInfo(emu, 0x15);
        this.stage16_CitySky = new StageInfo_1.StageInfo(emu, 0x16);
        this.stage17_PalaceTwilight = new StageInfo_1.StageInfo(emu, 0x17);
        this.stage18_HyruleCastle = new StageInfo_1.StageInfo(emu, 0x18);
        this.stage19_Cave1 = new StageInfo_1.StageInfo(emu, 0x19);
        this.stage1A_Cave2 = new StageInfo_1.StageInfo(emu, 0x1A);
        this.stage1B_Grottos = new StageInfo_1.StageInfo(emu, 0x1B);
        this.stage1C_Unk6 = new StageInfo_1.StageInfo(emu, 0x1C);
        this.stage1D_Unk7 = new StageInfo_1.StageInfo(emu, 0x1D);
        this.stage1E_Unk8 = new StageInfo_1.StageInfo(emu, 0x1E);
        this.stage1F_Unk9 = new StageInfo_1.StageInfo(emu, 0x1F);
    }
    get eventFlags() {
        return this.emulator.rdramReadBuffer(this.eventFlagAddr, 0xF0); // Bytes 0xF1 - 0x100 aren't bitfields..?
    }
    set eventFlags(flag) {
        this.emulator.rdramWriteBuffer(this.eventFlagAddr, flag);
    }
    get mapFlags() {
        return this.emulator.rdramReadBuffer(0x804067B0, 0x200);
    }
    set mapFlags(flag) {
        this.emulator.rdramWriteBuffer(0x804067B0, flag);
    }
    get itemFlags() {
        return this.emulator.rdramReadBuffer(0x8040628C, 0x20);
    }
    set itemFlags(flag) {
        this.emulator.rdramWriteBuffer(0x8040628C, flag);
    }
    get faronTears() {
        return this.emulator.rdramRead8(0x804062D4);
    }
    set faronTears(flag) {
        this.emulator.rdramWrite8(0x804062D4, flag);
    }
    get eldinTears() {
        return this.emulator.rdramRead8(0x804062D5);
    }
    set eldinTears(flag) {
        this.emulator.rdramWrite8(0x804062D5, flag);
    }
    get lanayruTears() {
        return this.emulator.rdramRead8(0x804062D6);
    }
    set lanayruTears(flag) {
        this.emulator.rdramWrite8(0x804062D6, flag);
    }
    get fusedShadowFlags() {
        return this.emulator.rdramReadBuffer(0x804062C9, 0x1);
    }
    set fusedShadowFlags(flag) {
        this.emulator.rdramWriteBuffer(0x804062C9, flag);
    }
    get twilightMirrorFlags() {
        return this.emulator.rdramReadBuffer(0x804062CA, 0x1);
    }
    set twilightMirrorFlags(flag) {
        this.emulator.rdramWriteBuffer(0x804062CA, flag);
    }
    get letterFlags() {
        return this.emulator.rdramReadBuffer(0x804062DC, 0x50);
    }
    set letterFlags(flag) {
        this.emulator.rdramWriteBuffer(0x804062DC, flag);
    }
    get charloDonation() {
        return this.emulator.rdramRead16(0x80406AA7);
    }
    set charloDonation(flag) {
        this.emulator.rdramWrite16(0x80406AA7, flag);
    }
    get maloDonation() {
        return this.emulator.rdramRead16(0x80406AA9);
    }
    set maloDonation(flag) {
        this.emulator.rdramWrite16(0x80406AA9, flag);
    }
}
exports.SaveContext = SaveContext;
//# sourceMappingURL=SaveContext.js.map